Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class Signature

    java.lang.Object
      java.security.SignatureSpi
          java.security.Signature

    public abstract class Signature

extends SignatureSpi

This Signature class is used to provide applications the functionality of a digital signature algorithm. Digital signatures are used for authentication and integrity assurance of digital data.

The signature algorithm can be, among others, the NIST standard DSA, using DSA and SHA-1. The DSA algorithm using the SHA-1 message digest algorithm can be specified as `SHA1withDSA`. In the case of RSA, there are multiple choices for the message digest algorithm, so the signing algorithm could be specified as, for example, `MD2withRSA`, `MD5withRSA`, or `SHA1withRSA`. The algorithm name must be specified, as there is no default.

A Signature object can be used to generate and verify digital signatures.

There are three phases to the use of a Signature object for either signing data or verifying a signature:

1. Initialization, with either
   - a public key, which initializes the signature for verification (see `initVerify`), or
   - a private key (and optionally a Secure Random Number Generator), which initializes the signature for signing (see `initSign(PrivateKey)` and `initSign(PrivateKey, SecureRandom)`).

2. Updating

   Depending on the type of initialization, this will update the bytes to be signed or verified. See the `update` methods.

3. Signing or Verifying a signature on all updated bytes. See the `sign` methods and the `verify` method.

Note that this class is abstract and extends from `SignatureSpi` for historical reasons. Application developers should only take notice of the methods defined in this `Signature` class; all the methods in the superclass are intended for cryptographic service providers who wish to supply their own implementations of digital signature algorithms.

Field Summary
`protected static int` | `SIGN` Possible `state` value, signifying that this signature object has been initialized for signing.
`protected int` | `state` Current state of this signature object.
`protected static int` | `UNINITIALIZED` Possible `state` value, signifying that this signature object has not yet been initialized.
`protected static int` | `VERIFY` Possible `state` value, signifying that this signature object has been initialized for verification.

Fields inherited from class java.security.SignatureSpi
`appRandom`

Constructor Summary
`protected` | `Signature(String algorithm)` Creates a Signature object for the specified algorithm.

Method Summary
`Object` | `clone()` Returns a clone if the implementation is cloneable.
`String` | `getAlgorithm()` Returns the name of the algorithm for this signature object.
`static Signature` | `getInstance(String algorithm)` Returns a Signature object that implements the specified signature algorithm.
`static Signature` | `getInstance(String algorithm, Provider provider)` Returns a Signature object that implements the specified signature algorithm.
`static Signature` | `getInstance(String algorithm, String provider)` Returns a Signature object that implements the specified signature algorithm.
`Object` | `getParameter(String param)` Deprecated.
`AlgorithmParameters` | `getParameters()` Returns the parameters used with this signature object.
`Provider` | `getProvider()` Returns the provider of this signature object.
`void` | `initSign(PrivateKey privateKey)` Initialize this object for signing.
`void` | `initSign(PrivateKey privateKey, SecureRandom random)` Initialize this object for signing.
`void` | `initVerify(Certificate certificate)` Initializes this object for verification, using the public key from the given certificate.
`void` | `initVerify(PublicKey publicKey)` Initializes this object for verification.
`void` | `setParameter(AlgorithmParameterSpec params)` Initializes this signature engine with the specified parameter set.
`void` | `setParameter(String param, Object value)` Deprecated. Use `setParameter`.
`byte[]` | `sign()` Returns the signature bytes of all the data updated.
`int` | `sign(byte[] outbuf, int offset, int len)` Finishes the signature operation and stores the resulting signature bytes in the provided buffer `outbuf`, starting at `offset`.
`String` | `toString()` Returns a string representation of this signature object, providing information that includes the state of the object and the name of the algorithm used.
`void` | `update(byte b)` Updates the data to be signed or verified by a byte.
`void` | `update(byte[] data)` Updates the data to be signed or verified, using the specified array of bytes.
`void` | `update(byte[] data, int off, int len)` Updates the data to be signed or verified, using the specified array of bytes, starting at the specified offset.
`void` | `update(ByteBuffer data)` Updates the data to be signed or verified using the specified ByteBuffer.
`boolean` | `verify(byte[] signature)` Verifies the passed-in signature.
`boolean` | `verify(byte[] signature, int offset, int length)` Verifies the passed-in signature in the specified array of bytes, starting at the specified offset.

Methods inherited from class java.security.SignatureSpi
`engineGetParameter, engineGetParameters, engineInitSign, engineInitSign, engineInitVerify, engineSetParameter, engineSetParameter, engineSign, engineSign, engineUpdate, engineUpdate, engineUpdate, engineVerify, engineVerify`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### UNINITIALIZED

    protected static final int UNINITIALIZED

  Possible `state` value, signifying that this signature object has not yet been initialized.

  See Also:
    Constant Field Values

### SIGN

    protected static final int SIGN

  Possible `state` value, signifying that this signature object has been initialized for signing.

  See Also:
    Constant Field Values

### VERIFY

    protected static final int VERIFY

  Possible `state` value, signifying that this signature object has been initialized for verification.

  See Also:
    Constant Field Values

### state

    protected int state

  Current state of this signature object.

Constructor Detail

### Signature

    protected Signature(String algorithm)

  Creates a Signature object for the specified algorithm.

  Parameters:
    `algorithm` - the standard string name of the algorithm. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.

Method Detail

### getInstance

    public static Signature getInstance(String algorithm)
                                 throws NoSuchAlgorithmException

  Returns a Signature object that implements the specified signature algorithm.

  This method traverses the list of registered security Providers, starting with the most preferred Provider. A new Signature object encapsulating the SignatureSpi implementation from the first Provider that supports the specified algorithm is returned.

  Note that the list of registered providers may be retrieved via the `Security.getProviders()` method.

  Parameters:
    `algorithm` - the standard name of the algorithm requested. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
  Returns:
    the new Signature object.
  Throws:
    `NoSuchAlgorithmException` - if no Provider supports a Signature implementation for the specified algorithm.
  See Also:
    `Provider`

### getInstance

    public static Signature getInstance(String algorithm,
                                        String provider)
                                 throws NoSuchAlgorithmException,
                                        NoSuchProviderException

  Returns a Signature object that implements the specified signature algorithm.

  A new Signature object encapsulating the SignatureSpi implementation from the specified provider is returned. The specified provider must be registered in the security provider list.

  Note that the list of registered providers may be retrieved via the `Security.getProviders()` method.

  Parameters:
    `algorithm` - the name of the algorithm requested. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
    `provider` - the name of the provider.
  Returns:
    the new Signature object.
  Throws:
    `NoSuchAlgorithmException` - if a SignatureSpi implementation for the specified algorithm is not available from the specified provider.
    `NoSuchProviderException` - if the specified provider is not registered in the security provider list.
    `IllegalArgumentException` - if the provider name is null or empty.
  See Also:
    `Provider`

### getInstance

    public static Signature getInstance(String algorithm,
                                        Provider provider)
                                 throws NoSuchAlgorithmException

  Returns a Signature object that implements the specified signature algorithm.

  A new Signature object encapsulating the SignatureSpi implementation from the specified Provider object is returned. Note that the specified Provider object does not have to be registered in the provider list.

  Parameters:
    `algorithm` - the name of the algorithm requested. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
    `provider` - the provider.
  Returns:
    the new Signature object.
  Throws:
    `NoSuchAlgorithmException` - if a SignatureSpi implementation for the specified algorithm is not available from the specified Provider object.
    `IllegalArgumentException` - if the provider is null.
  Since:
    1.4
  See Also:
    `Provider`

### getProvider

    public final Provider getProvider()

  Returns the provider of this signature object.

  Returns:
    the provider of this signature object

### initVerify

    public final void initVerify(PublicKey publicKey)
                          throws InvalidKeyException

  Initializes this object for verification. If this method is called again with a different argument, it negates the effect of this call.

  Parameters:
    `publicKey` - the public key of the identity whose signature is going to be verified.
  Throws:
    `InvalidKeyException` - if the key is invalid.

### initVerify

    public final void initVerify(Certificate certificate)
                          throws InvalidKeyException

  Initializes this object for verification, using the public key from the given certificate.

  If the certificate is of type X.509 and has a key usage extension field marked as critical, and the value of the key usage extension field implies that the public key in the certificate and its corresponding private key are not supposed to be used for digital signatures, an `InvalidKeyException` is thrown.

  Parameters:
    `certificate` - the certificate of the identity whose signature is going to be verified.
  Throws:
    `InvalidKeyException` - if the public key in the certificate is not encoded properly or does not include required parameter information or cannot be used for digital signature purposes.
  Since:
    1.3

### initSign

    public final void initSign(PrivateKey privateKey)
                        throws InvalidKeyException

  Initialize this object for signing. If this method is called again with a different argument, it negates the effect of this call.

  Parameters:
    `privateKey` - the private key of the identity whose signature is going to be generated.
  Throws:
    `InvalidKeyException` - if the key is invalid.

### initSign

    public final void initSign(PrivateKey privateKey,
                               SecureRandom random)
                        throws InvalidKeyException

  Initialize this object for signing. If this method is called again with a different argument, it negates the effect of this call.

  Parameters:
    `privateKey` - the private key of the identity whose signature is going to be generated.
    `random` - the source of randomness for this signature.
  Throws:
    `InvalidKeyException` - if the key is invalid.

### sign

    public final byte[] sign()
                      throws SignatureException

  Returns the signature bytes of all the data updated. The format of the signature depends on the underlying signature scheme.

  A call to this method resets this signature object to the state it was in when previously initialized for signing via a call to `initSign(PrivateKey)`. That is, the object is reset and available to generate another signature from the same signer, if desired, via new calls to `update` and `sign`.

  Returns:
    the signature bytes of the signing operation's result.
  Throws:
    `SignatureException` - if this signature object is not initialized properly or if this signature algorithm is unable to process the input data provided.

### sign

    public final int sign(byte[] outbuf,
                          int offset,
                          int len)
                   throws SignatureException

  Finishes the signature operation and stores the resulting signature bytes in the provided buffer `outbuf`, starting at `offset`. The format of the signature depends on the underlying signature scheme.

  This signature object is reset to its initial state (the state it was in after a call to one of the `initSign` methods) and can be reused to generate further signatures with the same private key.

  Parameters:
    `outbuf` - buffer for the signature result.
    `offset` - offset into `outbuf` where the signature is stored.
    `len` - number of bytes within `outbuf` allotted for the signature.
  Returns:
    the number of bytes placed into `outbuf`.
  Throws:
    `SignatureException` - if this signature object is not initialized properly, if this signature algorithm is unable to process the input data provided, or if `len` is less than the actual signature length.
  Since:
    1.2

### verify

    public final boolean verify(byte[] signature)
                         throws SignatureException

  Verifies the passed-in signature.

  A call to this method resets this signature object to the state it was in when previously initialized for verification via a call to `initVerify(PublicKey)`. That is, the object is reset and available to verify another signature from the identity whose public key was specified in the call to `initVerify`.

  Parameters:
    `signature` - the signature bytes to be verified.
  Returns:
    true if the signature was verified, false if not.
  Throws:
    `SignatureException` - if this signature object is not initialized properly, the passed-in signature is improperly encoded or of the wrong type, if this signature algorithm is unable to process the input data provided, etc.

### verify

    public final boolean verify(byte[] signature,
                                int offset,
                                int length)
                         throws SignatureException

  Verifies the passed-in signature in the specified array of bytes, starting at the specified offset.

  A call to this method resets this signature object to the state it was in when previously initialized for verification via a call to `initVerify(PublicKey)`. That is, the object is reset and available to verify another signature from the identity whose public key was specified in the call to `initVerify`.

  Parameters:
    `signature` - the signature bytes to be verified.
    `offset` - the offset to start from in the array of bytes.
    `length` - the number of bytes to use, starting at offset.
  Returns:
    true if the signature was verified, false if not.
  Throws:
    `SignatureException` - if this signature object is not initialized properly, the passed-in signature is improperly encoded or of the wrong type, if this signature algorithm is unable to process the input data provided, etc.
    `IllegalArgumentException` - if the `signature` byte array is null, or the `offset` or `length` is less than 0, or the sum of the `offset` and `length` is greater than the length of the `signature` byte array.
  Since:
    1.4

### update

    public final void update(byte b)
                      throws SignatureException

  Updates the data to be signed or verified by a byte.

  Parameters:
    `b` - the byte to use for the update.
  Throws:
    `SignatureException` - if this signature object is not initialized properly.

### update

    public final void update(byte[] data)
                      throws SignatureException

  Updates the data to be signed or verified, using the specified array of bytes.

  Parameters:
    `data` - the byte array to use for the update.
  Throws:
    `SignatureException` - if this signature object is not initialized properly.

### update

    public final void update(byte[] data,
                             int off,
                             int len)
                      throws SignatureException

  Updates the data to be signed or verified, using the specified array of bytes, starting at the specified offset.

  Parameters:
    `data` - the array of bytes.
    `off` - the offset to start from in the array of bytes.
    `len` - the number of bytes to use, starting at offset.
  Throws:
    `SignatureException` - if this signature object is not initialized properly.

### update

    public final void update(ByteBuffer data)
                      throws SignatureException

  Updates the data to be signed or verified using the specified ByteBuffer. Processes the `data.remaining()` bytes starting at at `data.position()`. Upon return, the buffer's position will be equal to its limit; its limit will not have changed.

  Parameters:
    `data` - the ByteBuffer
  Throws:
    `SignatureException` - if this signature object is not initialized properly.
  Since:
    1.5

### getAlgorithm

    public final String getAlgorithm()

  Returns the name of the algorithm for this signature object.

  Returns:
    the name of the algorithm for this signature object.

### toString

    public String toString()

  Returns a string representation of this signature object, providing information that includes the state of the object and the name of the algorithm used.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this signature object.

### setParameter

    @Deprecated
    public final void setParameter(String param,
                                              Object value)
                            throws InvalidParameterException

  Deprecated. Use `setParameter`.

  Sets the specified algorithm parameter to the specified value. This method supplies a general-purpose mechanism through which it is possible to set the various parameters of this object. A parameter may be any settable parameter for the algorithm, such as a parameter size, or a source of random bits for signature generation (if appropriate), or an indication of whether or not to perform a specific but optional computation. A uniform algorithm-specific naming scheme for each parameter is desirable but left unspecified at this time.

  Parameters:
    `param` - the string identifier of the parameter.
    `value` - the parameter value.
  Throws:
    `InvalidParameterException` - if `param` is an invalid parameter for this signature algorithm engine, the parameter is already set and cannot be set again, a security exception occurs, and so on.
  See Also:
    `getParameter(java.lang.String)`

### setParameter

    public final void setParameter(AlgorithmParameterSpec params)
                            throws InvalidAlgorithmParameterException

  Initializes this signature engine with the specified parameter set.

  Parameters:
    `params` - the parameters
  Throws:
    `InvalidAlgorithmParameterException` - if the given parameters are inappropriate for this signature engine
  See Also:
    `getParameters()`

### getParameters

    public final AlgorithmParameters getParameters()

  Returns the parameters used with this signature object.

  The returned parameters may be the same that were used to initialize this signature, or may contain a combination of default and randomly generated parameter values used by the underlying signature implementation if this signature requires algorithm parameters but was not initialized with any.

  Returns:
    the parameters used with this signature, or null if this signature does not use any parameters.
  Since:
    1.4
  See Also:
    `setParameter(AlgorithmParameterSpec)`

### getParameter

    @Deprecated
    public final Object getParameter(String param)
                              throws InvalidParameterException

  Deprecated.

  Gets the value of the specified algorithm parameter. This method supplies a general-purpose mechanism through which it is possible to get the various parameters of this object. A parameter may be any settable parameter for the algorithm, such as a parameter size, or a source of random bits for signature generation (if appropriate), or an indication of whether or not to perform a specific but optional computation. A uniform algorithm-specific naming scheme for each parameter is desirable but left unspecified at this time.

  Parameters:
    `param` - the string name of the parameter.
  Returns:
    the object that represents the parameter value, or null if there is none.
  Throws:
    `InvalidParameterException` - if `param` is an invalid parameter for this engine, or another exception occurs while trying to get this parameter.
  See Also:
    `setParameter(String, Object)`

### clone

    public Object clone()
                 throws CloneNotSupportedException

  Returns a clone if the implementation is cloneable.

  Overrides:
    `clone` in class `SignatureSpi`
  Returns:
    a clone if the implementation is cloneable.
  Throws:
    `CloneNotSupportedException` - if this is called on an implementation that does not support `Cloneable`.
  See Also:
    `Cloneable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2008 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.